/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
/*******************************************************************************
This class is used to get:
1. Providers;
2. ProviderPlugins;

and provide the registered and configured Providers and ProviderPlugins to
testSuite to test against.

 ******************************************************************************/
package com.ibm.rational.test.lm.spi.driver.test.util;

import java.util.HashMap;

import com.ibm.rational.test.lm.spi.IAutomationSPI;

public class PRAutomation extends PluginReader {

    private static final String CATEGORY_AUTOMATION = "Automation";
    private final String jobDefinitionUrlPart = "/jobDefinition/";
    
    private IAutomationSPI[] automationProviders = null;
    private String[] automationProviderPluginIds = null;
    
    private static HashMap<String, String> providerToConfig = new HashMap<String, String>();

	@Override
	public boolean init() {
		
        boolean success = false;

        providerToConfig = ProviderXml.getAutomationProviderDocs();       
        success = providerToConfig.size() > 0;
        
        
        //get the automation providers and pluginIds...
        automationProviders = Registry.getRegistry().getAutomationProviders();
        automationProviderPluginIds = Registry.getRegistry().getAutomationProviderPluginIds();
        
        super.setProviders(automationProviders);
        super.setProviderPluginIds(automationProviderPluginIds);
        super.setCategory(CATEGORY_AUTOMATION);
        super.setCategoryPartURL(jobDefinitionUrlPart);
        super.setProviderToConfig(providerToConfig);
        
        
		return success;
	}

}
