/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
package com.ibm.rational.test.lm.spi.sample.util;

import java.io.ByteArrayOutputStream;
import java.io.OutputStream;
import java.util.HashMap;

import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.xmi.XMLResource;

import com.ibm.ccl.soa.deploy.core.CoreFactory;
import com.ibm.ccl.soa.deploy.core.DeployCoreRoot;
import com.ibm.ccl.soa.deploy.core.Topology;

public class TopologyUtils 
{
    @SuppressWarnings("unchecked")
    public static String topologyToXml(Topology topology)
    {
        String topologyXml = "";
        Resource res = topology.eResource();
        if (res == null) 
        {
            ResourceSet rs = new ResourceSetImpl();
            res = rs.createResource(org.eclipse.emf.common.util.URI.createURI("resource.extension"));
            DeployCoreRoot root = CoreFactory.eINSTANCE.createDeployCoreRoot();
            root.setTopology(topology);
            res.getContents().add(root);
        }
        try 
        {
            HashMap options = new HashMap();
            options.put(XMLResource.OPTION_EXTENDED_META_DATA, Boolean.TRUE);
            OutputStream os = new ByteArrayOutputStream();
            res.save(os, options);
            topologyXml = os.toString();
        }
        catch (Exception e)
        {            
        }
        return topologyXml;
    }
}
